#!/usr/bin/perl

#    
$config="/etc/bforce/sln_sfp.conf";







###############################################################################
### Programm ################################################### do't edit! ###
###############################################################################

use Time::Local;
exit unless $ARGV[0];

$ver='Sln ! freq processor v0.2 (DBM edition)';








### Parse config ##############################################################
$db_area=$db_access=$db_file=$db_limit=undef;
$my=$note=$log=$mincps=$dul=$dup=$code=$maxfile=undef;
$err0=$err1=$err2=$err3=$err4=$err5=$err6=$err7=$err8=undef;
undef %addr;
undef %alias;

open(CFG, "< $config") || die "$config ($!)";
while($_=<CFG>){

$db_area=$1	if /^db_area\s+(.+)$/i;
$db_access=$1	if /^db_access\s+(.+)$/i;
$db_file=$1	if /^db_file\s+(.+)$/i;
$db_limit=$1	if /^db_limit\s+(.+)$/i;

$my=$1		if /^my\s+(.+)/i;
$note=$1	if /^note\s+(.+)/i;
$log=$1		if /^log\s+(.+)/i;
$mincps=$1	if /^min_cps\s+(\d+)/i;
$dul=$1		if /^deny_unlist\s+(\d)/i;
$dup=$1		if /^deny_unprot\s+(\d)/i;
$code=$1	if /^recode\s+(.+)/i;
$maxfile=$1	if /^max_files\s+(\d+)/i;
$addr{$1}=$2	if /^addr\s+(\S+)\s+(.+)/i;
$alias{$1}=$2	if /^alias\s+(\S+)\s+(.+)/i;

$err0=$1	if /^err_req\s+(.+)/i;
$err1=$1	if /^err_cps\s+(.+)/i;
$err2=$1	if /^err_list\s+(.+)/i;
$err3=$1	if /^err_prot\s+(.+)/i;
$err4=$1	if /^err_maxfiles\s+(.+)/i;
$err5=$1	if /^err_access\s+(.+)/i;
$err6=$1	if /^err_limit\s+(.+)/i;
$err7=$1	if /^err_nfound\s+(.+)/i;
$err8=$1	if /^err_found\s+(.+)/i;

}
close CFG;

err("Can not get main param from config") unless $my and $log and %addr and %alias;
err("Can not get err param from config") unless $err0 and $err1 and $err2 and $err3 and $err4 and $err5 and $err6 and $err7 and $err8;
err("Can not get db param from config") unless $db_area and $db_access and $db_file and $db_limit;

loging("Starting $ver");










### Loading/parsing recode file ###############################################

if($code){
open(CODE, "< $code") || err("$code ($!)");
$in=$out='';
while($_=<CODE>){ $in.="\\$1",$out.="\\$2" if /^0+(x[\da-f]+)\s+0+(x[\da-f]+)$/i }
close(CODE);
}









### Loading/parse srif-file ###################################################

$aka=$req=$res=$lst=$prt=$cps=$sysop=undef;
open(SF, "< $ARGV[0]") || err("$ARGV[0] ($!)");

while($_=<SF>){

$aka=$1		if /^aka\s+([\d:\/\.]+)/i;
$req=$1		if /^requestlist\s+(.+)/i;
$res=$1		if /^responselist\s+(.+)/i;
$lst=lc($1)	if /^systemstatus\s+(.+)/i;
$prt=lc($1)	if /^remotestatus\s+(.+)/i;
$cps=$1		if /^baud\s+(\d+)/i;
$sysop=$1	if /^sysop\s+(.+)/i;

}
close SF;
err("Can not get main param from srif-file") unless $aka and $req and $res and $lst and $prt and $cps and $sysop;

loging("System: $aka ($cps, $lst, $prt)");
loging("SysOp: $sysop");


undef @send;
undef @msg;
undef %rf;
$totnum=0;
$totsize=0;
mkmsg1("Request result:");
mkmsg1("="x78);









### Check system ##############################################################

mkmsg1($err1), goto fmsg1 if $mincps and $cps < $mincps;
mkmsg1($err2), goto fmsg1 if $dul and $lst eq "unlisted";
mkmsg1($err3), goto fmsg1 if $dup and $prt eq "unprotected";













### Get request file ##########################################################
open(RF, "< $req") || err("$req ($!)");
while($_=<RF>){ $rf{lc($1)}='' if /^([^\|\s]+)/ }
close RF;

mkmsg1($err0), goto fmsg1 if scalar keys %rf == 0;

loging("Freq files: ".(join " ", sort keys %rf));









### Get limits ################################################################
($z,$n,$f,$p)=split /[\.\/\:]/,$aka;
$p="0" unless $p;
$addr=$addr{"*"} if exists $addr{"*"};
$addr=$addr{"$z:*/*.*"} if exists $addr{"$z:*/*.*"};
$addr=$addr{"$z:$n/*.*"} if exists $addr{"$z:$n/*.*"};
$addr=$addr{"$z:$n/$f.*"} if exists $addr{"$z:$n/$f.*"};
$addr=$addr{"$z:$n/$f.$p"} if exists $addr{"$z:$n/$f.$p"};

mkmsg1($err2), goto fmsg1 unless $addr;

if($addr=~/^(\d+):(\d+)\s+(\d+):(\d+)\s+(\d+).(\d+).(\d+)/){
    if(time() < timelocal(0,0,0,$5,$6-1,$7)){ $file=$1;$access=$3 }
    else{ $file=$2;$access=$4 }
}elsif($addr=~/^(\d+)\s+(\d+)/){ $file=$1;$access=$2 }
else{ err("Config file have error for $aka") }

loging("Access: $access, file: $file");

dbmopen(%limit,$db_limit,0600) || err("$db_limit ($!)");

if(exists $limit{$aka}){
 @t=localtime();
 @_=split /\0/,$limit{$aka};
  $file=$_[1] if $t[7] == $_[0];
}

loging("Get spent file limit");
loging("Today file: $file");









### Work with aliases #########################################################
foreach (sort keys %alias){
if(exists $rf{lc($_)}){
   delete $rf{lc($_)};
   $rf{$alias{lc($_)}}='';
}
}









### Get files from file base ##################################################
dbmopen(%area,$db_area,0600) || err("$db_area ($!)");
dbmopen(%acc,$db_access,0600) || err("$db_access ($!)");
dbmopen(%file,$db_file,0600) || err("$db_file ($!)");

undef %f;
undef %i;
foreach $id (keys %file){
foreach(split /\0/,$file{$id}){ ($f{lc($_)},$i{lc($_)})=($_,$id) if exists $rf{lc($_)} }
}









### Make results ##############################################################

foreach $f (sort keys %f){

    # check file on disk
    mkmsg0($f,"-",  "-",  $acc{$i{$f}},$err7), next unless ($size,$date)=(stat("$area{$i{$f}}/$f{$f}"))[7,9];

    # check access
    mkmsg0($f,$size,$date,$acc{$i{$f}},$err5), next if $acc{$i{$f}} > $access and -r "$area{$i{$f}}/$f{$f}";

    # check limits
    mkmsg0($f,$size,$date,$acc{$i{$f}},$err6), next if $size > $file;

    # check maxfiles
    mkmsg0($f,$size,$date,$acc{$i{$f}},$err4), next if $maxfile and $totnum >= $maxfile;

    # hmm... ok send
    mkmsg0($f,$size,$date,$acc{$i{$f}},$err8);
    push @send, "$area{$i{$f}}/$f{$f}";
        $totnum++;
	$file-=$size;
        $totsize+=$size;
}











fmsg0:
### Not found files ###########################################################
foreach (sort keys %rf){ mkmsg0($_,"-","-","-",$err7) if not exists $f{lc($_)} }



fmsg1:
### Footer ####################################################################
mkmsg1("="x78);
mkmsg1("Sended $totnum of ".(scalar keys %rf)." files at $totsize bytes");
mkmsg1("Today left limit $file bytes");
mkmsg1("="x78);

loging("Total sent $totnum files at $totsize");










### notaice ###################################################################
if($note){
open(NOTE, "< $note") || err("$note ($!)");
 while($_=<NOTE>){
  chomp;
  mkmsg1($_);
 }
close NOTE;
}










### Make and write pkt ########################################################
loging("Make pkt file");

$pktname="/tmp/".sprintf("%lx",time-rand('999999')).".pkt";
open(PKT, "> $pktname") || err("$pktname ($!)");
print PKT mkpkt(join "\r",@msg);
close PKT;










### Write response list #######################################################
loging("Make response list");

open(RES, "> $res") || err("$res ($!)");
print RES "-$pktname\n";
print RES map{"+$_\n"} @send;
close RES;









### Update limits #############################################################
loging("Update file limit");

@_=localtime();
$limit{$aka}="$_[7]\0$file";



dbmclose(%area);
dbmclose(%acc);
dbmclose(%file);
dbmclose(%limit);








loging("Exit (errorlevel=0)\n");
exit 0;












### Sub programms #############################################################

sub loging{
my @t=localtime();
open(LOG, ">>$log") || die $!;
 print LOG sprintf("%02d/%02d/%02d %02d:%02d:%02d",$t[3],$t[4],substr($t[5],-2),$t[2],$t[1],$t[0])." sfdbm [$$] $_[0]\n";
close LOG;
}




sub mkmsg0{
my ($file,$size,$date,$acc,$desc)=@_;
 $line=f2s($file).s2s($size).t2s($date);
  loging(f2s($file)." (access: $acc, size: $size [$desc])");

d2s($line,$desc);
}





sub mkmsg1{ d2s('',@_) }





sub f2s{ substr(uc($_[0]),0,12)." "x(12-length $_[0]) }
sub s2s{ sprintf(" % 8s ",$_[0]) }





sub t2s{
if($_[0]=~/^\d+$/){
 my @t=localtime($_[0]);
 sprintf("%02d/%02d/%04d ",$t[3],$t[4],$t[5]+1900);
}else{
 "         - ";
}}






sub d2s{
my ($line,$str)=@_;
 eval "\$str=~tr/$in/$out/" if $code;
 @dsc=split /[\n\r]/,$str;
  push @msg, substr(($line.shift @dsc),0,78);
  push @msg, substr((" "x33).$_,0,78) foreach (@dsc);
}





sub err{
loging("$_[0]");
loging("Exit (errorlevel=1)\n");
exit 1;
}




sub mkpkt{
$body=$_[0];

@orig=split /[\:\/\.]/, $my;
@dest=split /[\:\/\.]/, $aka;
$orig[3]='0' unless $orig[3];
$dest[3]='0' unless $dest[3];

@time=localtime;
@month=("Jan","Feb","Mar","Apr","May","Jun",
        "Jul","Aug","Sep","Oct","Nov","Dec");

$header =pack("vvvvvvvvvvvvvA8vvvvvvvvvvVvvvvvvv",
	$orig[2],$dest[2],$time[5]+1900,$time[4],
	$time[3],$time[2],$time[1],$time[0],
	9600,    2,       $orig[1],$dest[1],
	1234,    '',	  $orig[0],$dest[0],
	0,       256,     1234,    1,
	$orig[0],$dest[0],$orig[3],$dest[3],
	0,       2,       $orig[2],$dest[2],
	$orig[1],$dest[1],1,       0);

$head =sprintf("%02d",$time[3])." $month[$time[4]] ".(substr $time[5],-2);
$head.="  ".sprintf("%02d:%02d:%02d",$time[2],$time[1],$time[0]);
$head.="\x00$sysop\x00FREQ processor\x00result\x00";

$cluge ="\x01INTL $dest[0]:$dest[1]/$dest[2] $orig[0]:$orig[1]/$orig[2]\x0D";
$cluge.="\x01TOPT $dest[3]\x0D" if $dest[3] != 0;
$cluge.="\x01FMPT $orig[3]\x0D" if $orig[3] != 0;
$cluge.="\x01MSGID: $my ".sprintf("%lx",time)."\x0D\x0D\x0A";

$footer="\x0D\x0D--- $ver\x0D";

$header.$head.$cluge.$body.$footer;
}
